//
// PLBot - OLO's bot
//
// (http://www.olo.counter-strike.pl/)
//
// bot_buy.cpp
//
/*
 * Copyright (c) 2004 OLO
 * This file is a part of PLBot application.
 * You are not allowed to remove these copyrights.
 */

#include <extdll.h>
#include <sdk_util.h>
#include <cbase.h>
#include <player.h>

#include <dllapi.h>
#include <meta_api.h>
#include <sdk_util.h>

#include "bot.h"
#include "plbot_api.h"  // me

extern bool g_bIsSteam;

typedef struct
{
   int iId;   //ID of weapon
   int cost;   //his cost
   char f_key[4];  //first key in buy menu
   char s_key[4];  //second key in buy menu
   char s_key_ct16[4];  //second key in buy menu (CS 1.6 CT)
   char s_key_t16[4];  //second key in buy menu (CS 1.6 T)
   char menu[12];  //menu
   int use_percent; //percent usage
   int for_who;  //all teams can buy?
   int state;   //says what kind of item it is
}
bot_buyequip_struct;

typedef struct
{
   int state;   //kind of menu (equip or just weap)
   char menu[12];  //menu
   int act;   //menu action
}
bot_buymenu_struct;

bot_buyequip_struct bot_buyequip[] = {

   {CS_WEAPON_M4A1,      3100, "4","3","3","0","buy",  25, CLIENT_CT, 0},
   {CS_WEAPON_SG552,     3500, "4","2","0","4","buy",  25, CLIENT_TERRORIST, 0},
   {CS_WEAPON_GALIL,     2000, "4","0","0","1","buy",  25, CLIENT_TERRORIST, 0},
   {CS_WEAPON_FAMAS,     2250, "4","0","0","1","buy",  25, CLIENT_CT, 0},
   {CS_WEAPON_AK47,      2500, "4","1","0","2","buy",  25, CLIENT_TERRORIST, 0},
   {CS_WEAPON_AUG,       3500, "4","4","4","0","buy",  25, CLIENT_CT, 0},
   {CS_WEAPON_AWP,       4750, "4","6","6","5","buy",  30, CLIENT_ALLTEAMS, 0},
   {CS_WEAPON_P90,       2350, "3","3","4","4","buy",  30, CLIENT_ALLTEAMS, 0},
   {CS_WEAPON_M249,      5750, "5","1","1","1","buy",  30, CLIENT_ALLTEAMS, 0},
   {CS_WEAPON_M3,        1700, "2","1","1","1","buy",  30, CLIENT_ALLTEAMS, 0},
   {CS_WEAPON_UMP45,     1700, "3","5","3","3","buy",  30, CLIENT_ALLTEAMS, 0},
   {CS_WEAPON_XM1014,    3000, "2","2","3","2","buy",  30, CLIENT_ALLTEAMS, 0},
   {CS_WEAPON_MAC10,     1400, "3","4","0","1","buy",  60, CLIENT_TERRORIST, 0},
   {CS_WEAPON_MP5NAVY,   1500, "3","1","2","2","buy",  60, CLIENT_ALLTEAMS, 0},
   {CS_WEAPON_G3SG1,     5000, "4","7","0","6","buy",  50, CLIENT_TERRORIST, 0},
   {CS_WEAPON_SG550,     4200, "4","8","5","0","buy",  50, CLIENT_CT, 0},
   {CS_WEAPON_TMP,       1250, "3","2","1","0","buy",  50, CLIENT_CT, 0},
   {CS_WEAPON_SCOUT,     2750, "4","5","2","3","buy",  30, CLIENT_ALLTEAMS, 0},

   {CS_WEAPON_ELITE,     1000, "1","5","0","5","buy",  40, CLIENT_TERRORIST, 0},
   {CS_WEAPON_DEAGLE,    650,  "1","3","4","4","buy",  50, CLIENT_ALLTEAMS, 0},
   {CS_WEAPON_P228,      600 , "1","4","3","3","buy",  30, CLIENT_ALLTEAMS, 0},
   {CS_WEAPON_FIVESEVEN, 750,  "1","6","5","0","buy",  30, CLIENT_CT, 0},
   {CS_WEAPON_USP,       500,  "1","1","2","2","buy",  30, CLIENT_ALLTEAMS, 0},
   {CS_WEAPON_GLOCK18,   400,  "1","2","1","1","buy",  20, CLIENT_ALLTEAMS, 0},

   {CS_WEAPON_HELMET,    1000, "2","","","", "buyequip", 100,CLIENT_ALLTEAMS, 1},
   {CS_WEAPON_VEST,      650,  "1","","","", "buyequip", 100,CLIENT_ALLTEAMS, 1},

   {CS_WEAPON_HEGRENADE, 300,  "4","","","", "buyequip", 90, CLIENT_ALLTEAMS, 8},
   {CS_WEAPON_FLASHBANG, 200,  "3","","","", "buyequip", 60, CLIENT_ALLTEAMS, 8},
   {CS_WEAPON_SMOKEGRENADE,300,"5","","","", "buyequip", 60, CLIENT_ALLTEAMS, 8},
   {CS_WEAPON_DEFKIT,    200,  "6","","","", "buyequip", 100,CLIENT_CT, 8},
   {CS_WEAPON_GOGGLES,   1250, "7","","","", "buyequip", 0, CLIENT_ALLTEAMS, 8},

   //Terminator
   {0, 0, "", "", "", "", "", 0, 0, 0}
};

bot_buymenu_struct bot_buymenu[] = {

   {0, "buy",  MSG_CS_WEAPON_SELECT},
   {1, "buyequip", MSG_CS_EQUIP_SELECT},
   {2, "buyammo1", MSG_CS_IDLE},
   {3, "buyammo1", MSG_CS_IDLE},
   {4, "buyammo1", MSG_CS_IDLE},
   {5, "buyammo2", MSG_CS_IDLE},
   {6, "buyammo2", MSG_CS_IDLE},
   {7, "buyammo2", MSG_CS_IDLE},
   {8, "buyequip", MSG_CS_EQUIP_SELECT},

   //Terminator
   {0, "",   0},
};

//Here we can buy items
bool BotBuyEquip(player_t *pBot )
{
   //Well we have bought all so don't keep buying
   if (pBot->buy_state > 8)
      return FALSE;

   //Bot is VIP so don't buy anything
   if (pBot->player_team & CLIENT_VIP)
   {
      pBot->buy_state = 9;
      return FALSE;
   }

   //Well we have to wait a bit
   if (pBot->buy_time > gpGlobals->time)
      return TRUE;

   //We already have good weapon so don't buy any new weapon
   if (pBot->buy_state == 0 && (HaveRifle(pBot) || HaveSniperRifle(pBot)))
      pBot->buy_state = 1;

   //Random time for buying next item
   pBot->buy_time = gpGlobals->time + RANDOM_FLOAT(0.1, 0.2);
   bot_buyequip_struct *pSelect = NULL;
   bot_buymenu_struct *pMenu = NULL;
   pMenu = &bot_buymenu[0];
   pSelect = &bot_buyequip[0];
   int select_index = 0;
   int use_percent;

   //Go throw list of menu and buy what you need
   while (pMenu[select_index].act)
   {
      //Check if this menu is to be apper in this turn of buying
      if (pMenu[select_index].state != pBot->buy_state)
      {
         select_index++;
         continue;
      }

      //If yes execute buy menu
      FakeClientCommand(pBot->pEdict, pMenu[select_index].menu , NULL, NULL);

      //Menu appear Reset menu action
      pBot->start_action = MSG_CS_IDLE;
      select_index = 0; //reset select index

      while (pSelect[select_index].iId)
      {
         //This is moment to buy this item so keep on searching
         if (pSelect[select_index].state != pBot->buy_state)
         {
            select_index++;
            continue;
         }

         use_percent = RANDOM_LONG(1, 100);

         // Skip CS1.6-only weapons if not in 1.6
         if (!g_bIsSteam &&
               (pSelect[select_index].iId == CS_WEAPON_FAMAS ||
                pSelect[select_index].iId == CS_WEAPON_GALIL))
         {
            select_index++;
            continue;
         }

         //Check buy percent, check if this team can buy this item
         if (((pSelect[select_index].for_who != CLIENT_ALLTEAMS)
               && (pBot->player_team != pSelect[select_index].for_who))
               || (use_percent > pSelect[select_index].use_percent))
         {
            select_index++;
            continue;
         }

         //Do we have enought money or don't we already have it?
         if ((pBot->pEdict->v.weapons & (1<<pSelect[select_index].iId))
               || (pBot->bot_money < pSelect[select_index].cost))
         {
            select_index++;
            continue;
         }

         FakeClientCommand(pBot->pEdict, "menuselect", pSelect[select_index].f_key , NULL);
         if (g_bIsSteam)
         {
            if (pBot->player_team == CLIENT_CT)
            {
               FakeClientCommand(pBot->pEdict, "menuselect", pSelect[select_index].s_key_ct16, NULL);
            }
            else
            {
               FakeClientCommand(pBot->pEdict, "menuselect", pSelect[select_index].s_key_t16, NULL);
            }
         }
         else
         {
            FakeClientCommand(pBot->pEdict, "menuselect", pSelect[select_index].s_key , NULL);
         }

         pBot->buy_state++; //We have bought it so go to the next turn of buying
         return TRUE;
      }

      //Well we haven't found anything to buy so go to the next turn
      pBot->buy_state++;
      return TRUE;
   }

   return TRUE;
}
