// vi: set ts=4 sw=4 :
// vim: set tw=75 :

// h_export.cpp - main exported DLL functionality

// From SDK dlls/h_export.cpp:

/***
*
* Copyright (c) 1999, 2000 Valve LLC. All rights reserved.
*
* This product contains software technology licensed from Id
* Software, Inc. ("Id Technology").  Id Technology (c) 1996 Id Software, Inc.
* All Rights Reserved.
*
*   Use, distribution, and modification of this source code and/or resulting
*   object code is restricted to non-commercial enhancements to products from
*   Valve LLC.  All other use, distribution, or modification is prohibited
*   without written permission from Valve LLC.
*
****/
/*
 
===== h_export.cpp ========================================================
 
  Entity classes exported by Halflife.
 
*/

/*
 * Copyright (c) 2004 OLO
 * This file is a part of PLBot application.
 * You are not allowed to remove these copyrights.
 */

#include <extdll.h>
#include <h_export.h>
#include <meta_api.h>

char g_argv[1024];
bool g_bIsSteam = FALSE; // true if running CS 1.6

#ifdef _WIN32
//! Required DLL entry point
// necessary for win9x ?
BOOL WINAPI DllMain( HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
   return TRUE;
}
#endif

//! Holds engine functionality callbacks
enginefuncs_t g_engfuncs;
globalvars_t *gpGlobals;

// Receive engine function table from engine.
// This appears to be the _first_ DLL routine called by the engine, so we
// do some setup operations here.
C_DLLEXPORT void WINAPI GiveFnptrsToDll( enginefuncs_t* pengfuncsFromEngine, globalvars_t *pGlobals )
{
   memcpy(&g_engfuncs, pengfuncsFromEngine, sizeof(enginefuncs_t));
   gpGlobals = pGlobals;

   // NOTE!  Have to call logging function _after_ copying into g_engfuncs, so
   // that g_engfuncs.pfnAlertMessage() can be resolved properly, heh. :)
   UTIL_LogPrintf("[%s] dev: called: GiveFnptrsToDll\n", Plugin_info.logtag);

   // see if we are running Counter-Strike v1.6...
   int i;
   unsigned char *tempbuf = LOAD_FILE_FOR_ME("sprites/weapon_famas.txt", &i);

   if (tempbuf)
   {
      g_bIsSteam = TRUE;
      FREE_FILE(tempbuf);
   }
}
